  /* Zadatak 10.1.8. (str. 113)

     Napisite funkciju koja dobiva prirodni broj n i provjerava
     je li n prost (vraca 1) ili ne (vraca 0).
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).

     Druga varijanta funkcije:
       - test mogucih netrivijalnih djelitelja od 2 do (int) sqrt(n).
     Sve petlje po djeliteljima su for petlje!

     Glavni program testira funkciju za zadani broj n = 1000000007.
  */

#include <stdio.h>
#include <math.h>

int prost_2(int n)
{
        /* Testira sve djelitelje od 2 do max_d = (int) sqrt(n). */

    int d;        /* Potencijalni djelitelj. */
    int max_d;    /* Maksimalni potencijalni djelitelj. */

        /* Brojevi <= 1 nisu prosti (ignoriramo <= 0). */
    if (n <= 1) return 0;


        /* Najveci djelitelj kojeg treba provjeriti je
             max_d = (int) sqrt(n).
           Naime, ako n nije prost, onda ima dva netrivijalna djelitelja,
           a manji od njih je najvise jednak max_d. Ako takav djelitelj od n
           ne postoji, onda je n prost. */
        /* Napomena: Zaokruzivanje sqrt(n) na donje cijelo je korektno
           na cijelom tipu za n, tj. ne moza se dogoditi da dobijemo za
           jedan premalo. Posebno, za brojeve n koji su potpun kvadrat,
           uvijek dobijemo korektan cjelobrojni korijen. */
    max_d = (int) sqrt(n);

        /* Petlja po mogucim djeliteljima od n od 2 do max_d. */
    for (d = 2; d <= max_d; ++d)
        if (n % d == 0) return 0;    /* Nije prost. */

    return 1;
}


int main(void)
{
    int n = 1000000007, prost;

    prost = prost_2(n);

        /* Ispis odgovora na pitanje je li broj n prost. */
    if (prost)
        printf(" Broj %d je prost\n", n);
    else
        printf(" Broj %d nije prost\n", n);

    return 0;
}
